﻿using System;
using Wisej.Web;

using System.Collections.Generic;
using WebApplication1.BO;

namespace MGTransportplanleggerWisej.Transportplanlegger
{
    public partial class TransportplanleggerWindow : Form
    {
        EditState mEState = EditState.EState_NoObject;


        #region " Form "

        private DataGridViewComboBoxColumn dataGridViewTransportPlanBilRadCUBRec;
        private DataGridViewComboBoxColumn dataGridViewTransportPlanBilRadCUKRec;

        public TransportplanleggerWindow()
        {
            InitializeComponent();
            if (DesignMode == false)
            {

                //dataGridViewTransportPlanBilRadCUBRec = new Wisej.Web.DataGridViewComboBoxColumn();
                //dataGridViewTransportPlanBilRadCUBRec.DataPropertyName = "CUBRec";
                //dataGridViewTransportPlanBilRadCUBRec.ValueMember = "CUBRec";
                //dataGridViewTransportPlanBilRadCUBRec.DisplayMember = "CUBBilnummer";
                //dataGridViewTransportPlanBilRadCUBRec.HeaderText = "Bilnummer";
                //dataGridViewTransportPlanBilRadCUBRec.DataSource = bindingSourceCUSTBilnummerList;
                //dataGridViewTransportPlanBilRads.Columns.Add(dataGridViewTransportPlanBilRadCUBRec);
                //dataGridViewTransportPlanBilRadCUBRec.DisplayIndex = 1;

                //dataGridViewTransportPlanBilRadCUKRec = new Wisej.Web.DataGridViewComboBoxColumn();
                //dataGridViewTransportPlanBilRadCUKRec.DataPropertyName = "CUKRec";
                //dataGridViewTransportPlanBilRadCUKRec.ValueMember = "CUKRec";
                //dataGridViewTransportPlanBilRadCUKRec.DisplayMember = "FultNavn";
                //dataGridViewTransportPlanBilRadCUKRec.HeaderText = "Sjåfør";
                //dataGridViewTransportPlanBilRadCUKRec.DataSource = bindingSourceCUSTKONTAKTERList;
                //dataGridViewTransportPlanBilRads.Columns.Add(dataGridViewTransportPlanBilRadCUKRec);
                //dataGridViewTransportPlanBilRadCUKRec.DisplayIndex = 5;

                UpdateControls();
            }
        }

        private void TransportplanleggerWindow_Load(object sender, EventArgs e)
        {
            try
            {
                bindingSourceTransportPlanBilRads.Add(new Knight(1,Title.King, "Uther", true));
                bindingSourceTransportPlanBilRads.Add(new Knight(2,Title.King, "Arthur", true));
                bindingSourceTransportPlanBilRads.Add(new Knight(3,Title.Sir, "Mordred", false));
                bindingSourceTransportPlanBilRads.Add(new Knight(4,Title.Sir, "Gawain", true));
                bindingSourceTransportPlanBilRads.Add(new Knight(5,Title.Sir, "Galahad", true));

                UpdateControls();
            }
            catch (Exception ex)
            {
            }

            try
            {
                WindowsRutiner.AdjustFormPosition(this);
            }
            catch (Exception ex)
            {
            }

        }

        private void TransportplanleggerWindow_FormClosing(object sender, FormClosingEventArgs e)
        {
            try
            {
            }
            catch (Exception ex)
            {
            }
        }

        #endregion


        #region " Binding events "

        private void TransportLevPuljeListbindingSource_CurrentItemChanged(object sender, EventArgs e)
        {
            try
            {
                GetSelectet();
            }
            catch (Exception ex)
            {
            }
            finally
            {
                dataGridViewTransportLevPuljeList.Enabled = true;
            }
        }

        #endregion

        #region " Toolbar click "

        private void ToolStrip_ButtonClick(object sender, ToolBarButtonClickEventArgs e)
        {
            if (e.Button.Name == "TSNew")
            {
                //TSNew_Click();
            }
            else if (e.Button.Name == "TSUpdate")
            {
                TSUpdate_Click();
            }
            else if (e.Button.Name == "TSDelete")
            {
                //TSDelete_Click();
            }
            else if (e.Button.Name == "toolBarButtonSok")
            {
                toolBarButtonSok_Click();
            }
            else if (e.Button.Name == "toolBarButtonDagens")
            {
                toolBarButtonDagens_Click();
            }
            else if (e.Button.Name == "toolBarButtonRefresh")
            {
                toolBarButtonRefresh_Click();

            }
            else if (e.Button.Name == "toolBarButtonLogg")
            {
                //toolBarButtonLogg_Click();
            }
            else if (e.Button.Name == "toolBarButtonSendEPost")
            {
                toolBarButtonSendEPost_Click();
            }
            else if (e.Button.Name == "toolBarButtonOversiktsrapport")
            {
                toolBarButtonOversiktsrapport_Click();
            }
            else if (e.Button.Name == "TSSave")
            {
                TSSave_Click();
            }
            else if (e.Button.Name == "TSCancel")
            {
                TSCancel_Click();
            }
        }

        void TSCancel_Click()
        {
        }

        void TSSave_Click()
        {
        }

        void TSNew_Click()
        {
            //try
            //{
            //    using (new NetForms.CursorKeeper(Cursors.WaitCursor))
            //    {
            //        mTransportLevPulje = TransportLevPulje.NewTransportLevPulje();
            //        TransportLevPuljeHeadbindingSourcebindingSource.DataSource = mTransportLevPulje;

            //        mEState = EditState.EState_NewObject;
            //        UpdateControls();
            //    }
            //}
            //catch (Exception ex)
            //{
            //    ErrorLog.Errormessage(ex);
            //}
            //finally
            //{
            //}
        }

        void TSUpdate_Click()
        {
            try
            {
                mEState = EditState.EState_EditingObject;
                UpdateControls();
            }
            catch (Exception ex)
            {
                //ErrorLog.Errormessage(ex);
            }
            finally
            {
            }
        }

        void TSDelete_Click()
        {
            //try
            //{
            //    if (MessageBox.Show("Vil du virkelig slette?", "Slett post", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2, true) == DialogResult.Yes)
            //    {
            //        using (new NetForms.CursorKeeper(Cursors.WaitCursor))
            //        {
            //            if ((TransportLevPuljeHeadbindingSourcebindingSource.Current != null))
            //            {
            //                int Rec = mTransportLevPulje.RAKRec;
            //                mTransportLevPulje.Delete();

            //                SaveProject(false);
            //                mTransportLevPuljeList.RemoveLine(Rec);
            //                TransportLevPuljeListbindingSource.DataSource = new MyCSLA.MySortableBindingList<TransportLevPuljeInfo>(mTransportLevPuljeList);
            //            }

            //            mEState = EditState.EState_LoadedObject;
            //            UpdateControls();
            //        }
            //    }
            //}
            //catch (Exception ex)
            //{
            //    ErrorLog.Errormessage(ex);
            //}
            //finally
            //{
            //}
        }

        void toolBarButtonDagens_Click()
        {
            try
            {
                GetSelectet();
            }
            catch (Exception ex)
            {
//                ErrorLog.Errormessage(ex);
            }
            finally
            {
            }
        }

        void toolBarButtonSok_Click()
        {
        }

        void toolBarButtonRefresh_Click()
        {
        }

        void toolBarButtonLogg_Click()
        {
        }

        void toolBarButtonSendEPost_Click()
        {
        }

        void toolBarButtonOversiktsrapport_Click()
        {
        }

        #endregion

        #region " Rutiner "

        private void GetSelectet()
        {
            {

                if (TransportLevPuljeListbindingSource.Current != null)
                {
                    //TransportLevPuljeInfo TransportLevPuljeInfo = (TransportLevPuljeInfo)TransportLevPuljeListbindingSource.Current;

                    //mTransportLevPuljeHead = TransportLevPuljeHead.GetTransportLevPuljeHead(TransportLevPuljeInfo.TLPRec);

//                    this.TransportLevPuljeHeadbindingSourcebindingSource.DataSource = mTransportLevPuljeHead;
                    mEState = EditState.EState_LoadedObject;
                    UpdateControls();
                }
                else
                {
                    //if ((mTransportLevPuljeHead != null))
                    //{
                    //    // cancel changes in memory
                    //    this.TransportLevPuljeHeadbindingSourcebindingSource.CancelEdit();
                    //    this.TransportLevPuljeHeadbindingSourcebindingSource.Clear();
                    //    mTransportLevPuljeHead = null;
                    //}
                    mEState = EditState.EState_NoObject;
                    UpdateControls();
                }
            }
        }

        private void AktiverToolbuttons(string TagValue)
        {
            foreach (ToolBarButton button in ToolStrip.Buttons)
            {
                if (button.Tag.ToString() == TagValue)
                {
                    button.Visible = true;
                }
                else
                {
                    button.Visible = false;
                }
            }
        }

        private void UpdateControls()
        {
            try
            {
                bool isEditing = mEState == EditState.EState_EditingObject | mEState == EditState.EState_NewObject;

                //if (mTransportLevPuljeHead == null)
                {
                    mEState = EditState.EState_NoObject;
                }

                WindowsRutiner.SetControlsState(this.Controls, mEState);

                //this.ReadWriteAuthorization1.ResetControlAuthorization();

            }
            catch //(Exception ex)
            {
                throw;
            }
            finally
            {
            }
        }

        private void SaveProject(bool rebind)
        {
            Exception tex = null;

            // stop the flow of events
            this.TransportLevPuljeHeadbindingSourcebindingSource.RaiseListChangedEvents = false;
            // apply changes in memory
            this.TransportLevPuljeHeadbindingSourcebindingSource.EndEdit();
            // do the save
            try
            {
                // clone the object
                //TransportLevPulje temp = mTransportLevPulje.Clone;
                //mTransportLevPulje = temp.Save;

                //mTransportLevPuljeHead = mTransportLevPuljeHead.Save();

                if (rebind)
                {
                    // rebind the UI
                    this.TransportLevPuljeHeadbindingSourcebindingSource.DataSource = null;
                    //this.TransportLevPuljeHeadbindingSourcebindingSource.DataSource = mTransportLevPuljeHead;
                    // check authorization
                    //ApplyAuthorizationRules();
                }

            }
            catch (Exception ex)
            {
                //MessageBox.Show(ex.ToString, "Error saving", MessageBoxButtons.OK, MessageBoxIcon.Error)
                tex = ex;
            }
            finally
            {
                // restore events
                this.TransportLevPuljeHeadbindingSourcebindingSource.RaiseListChangedEvents = true;
                // refresh the UI
                this.TransportLevPuljeHeadbindingSourcebindingSource.ResetBindings(false);

                UpdateControls();
                if ((tex != null))
                {
                    throw tex;
                }
            }

        }

        #endregion

        #region " Buttons click "

        private void buttonSendSamleSMS_Click(object sender, EventArgs e)
        {
        }

        private void buttonSendSMS_Click(object sender, EventArgs e)
        {
        }

        private void buttonSlettBil_Click(object sender, EventArgs e)
        {
        }

        private void buttonNyBil_Click(object sender, EventArgs e)
        {
            try
            {
//                mTransportLevPuljeHead.TransportPlanBilRads.AddNew();
            }
            catch (Exception ex)
            {
  //              ErrorLog.Errormessage(ex);
            }
            finally
            {
            }

        }

        private void buttonOverforTilBil_Click(object sender, EventArgs e)
        {
            try
            {
                dataGridViewTransportPlanBilRads.SuspendLayout();
                TransportAntallBilRadsdataGridView.SuspendLayout();
                if (dataGridViewTransportAvdelingRads.CurrentRow != null && dataGridViewTransportAvdelingRads.CurrentRow.DataBoundItem != null)
                {
                    if (dataGridViewTransportPlanBilRads.CurrentRow != null && dataGridViewTransportPlanBilRads.CurrentRow.DataBoundItem != null)
                    {
                        List<int> selectedindexes = new List<int>();
                        foreach (Wisej.Web.DataGridViewRow row in dataGridViewTransportAvdelingRads.SelectedRows) selectedindexes.Add(row.Index);
                        selectedindexes.Sort();
                        foreach (int index in selectedindexes)
                        {
                            //TransportPlanBilRad TransportPlanBilRad = (TransportPlanBilRad)dataGridViewTransportPlanBilRads.CurrentRow.DataBoundItem;
                            //TransportAvdelingRad TransportAvdelingRad = (TransportAvdelingRad)dataGridViewTransportAvdelingRads.Rows[index].DataBoundItem;
                            //if (TransportAvdelingRad.CCKaldRest > 0 || TransportAvdelingRad.CCVarmRest > 0 || TransportAvdelingRad.PallRest > 0)
                            //{
                            //    TransportPlanBilRad.LeggTilTransportAntall(TransportAvdelingRad);
                            //}
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                //ErrorLog.Errormessage(ex);
            }
            finally
            {
                dataGridViewTransportPlanBilRads.ResumeLayout();
                TransportAntallBilRadsdataGridView.ResumeLayout();
            }
        }

        private void buttonSlettIngarIBil_Click(object sender, EventArgs e)
        {
        }

        #endregion

        private void dataGridViewTransportLevPuljeList_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            try
            {
            }
            catch (Exception ex)
            {
            }
            finally
            {
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            WindowsRutiner.SetControlsState(this.Controls, EditState.EState_EditingObject);
        }
    }
}
